(***********************************************************************)
(*                                                                     *)
(*                       Ambients in JoCaml                            *)
(*                                                                     *)
(*               Alan Schmitt, projet Para, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1999 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

type ('a, 'b, 'c) t

val create : unit -> ('a, 'b, 'c) t
val add : ('a, 'b, 'c) t -> 'a -> 'b -> 'c -> unit

(* these functions may raise Not_found *)
val find_id : ('a, 'b, 'c) t -> 'b -> 'c
val find_name : ('a, 'b, 'c) t -> 'a -> 'b * 'c
val find_name_different : ('a, 'b, 'c) t -> 'a -> 'b -> 'b * 'c 
val remove : ('a, 'b, 'c) t -> 'b -> unit
val flush : ('a, 'b, 'c) t -> ('a -> 'b -> 'c -> unit) -> unit
val to_string : ('a, 'b, 'c) t -> ('a -> 'b -> 'c -> string) -> string

